#!/usr/local/bin/perl
# !+-------------------------------------------------------------------------
#    Name:  dbamon_inhibit.pl
# !*-------------------------------------------------------------------------

chop($P = `basename $0`);
$| = 1;

push(@INC,"/opt/apache/cgi-bin/");
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";

use DBI;
use Time::Local;
require "cgi_handlers.pl";

chop($hostname = `hostname`);
chop($fqhostname = `nslookup $hostname | grep Name: | awk '{ print \$2 }'`);

$dbms_comment = "--"; 
$fs = "<font size=2>"; 

$database = "dbamon";

$uptime_db_exclude = "
    'ghr03:GHRCOPY', 
    'ghr03:GHRHELP', 
    'ghr03:GMDSCOPY'
  "; 

$backup_tools_list = "
	'db_onbar',
	'dbexport',
	'mssql_backup',
	'ora_backup',
	'ora_backup_catexp',
	'ora_exp_bk',
	'ora_full_bk',
	'ora_omniback_backup',
	'ora_tbs_bk',
	'orant_backup',
	'orant_exp_bk',
	'orant_tbs_bk',
	'rman2ob',
	'rman2ob.pl'
"; 
$exclude_id3_list = "'Oracle-AMS','LSCA-SAP','HP-Avago-Ifmx'"; 

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  #$dbms = "oracle";
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  my $msg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  ##print "</center><br><font size=2>$date ${P} | <b>$msgmsg</b></font><center>\n";
  print "<br><font size=2>$date ${P} | <b>$msg</b></font>\n";
}

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input date ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   #print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h3> The following database error occured - $date<hr></h3>";
   print "</hr noshade>";
   &msg("$errorMsg");
   &msg("SQLError: $DBI::errstr");
   &msg("SQL: <pre>$sql</pre>");

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub error 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   #print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h3> The following database error occured - $date<hr></h3>";
   print "</hr noshade>";
   &msg("$errorMsg");
   &msg("SQLError: $DBI::errstr");
   &msg("SQL: <pre>$sql</pre>");

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub error_check
#-----------------------------------------------------------------------------
{
  # Convert start and end dates into seconds
  $s_mm = $rqpairs{'s_mm'}; $s_mm = "0$s_mm" if length($s_mm) == 1; 
  $e_mm = $rqpairs{'e_mm'}; $e_mm = "0$e_mm" if length($e_mm) == 1; 

  $s_date = "$rqpairs{'s_yyyy'}/$s_mm/$rqpairs{'s_dd'}-00:00:00";
  $e_date = "$rqpairs{'e_yyyy'}/$e_mm/$rqpairs{'e_dd'}-23:59:59";

  $s_mm = $rqpairs{'s_mm'}-1;
  $e_mm = $rqpairs{'e_mm'}-1;
  @date=(0,0,0,$rqpairs{'s_dd'},$s_mm,$rqpairs{'s_yyyy'});
  $s_sec = &timelocal(@date);
  @date=(0,0,0,$rqpairs{'e_dd'},$e_mm,$rqpairs{'e_yyyy'});

  $e_sec = &timelocal(@date);

  if ($e_sec <= $s_sec)
  {
     push (@error_list, "Reporting Period End Date ($e_date) Must Be Greater Than Start Date ($s_date)\n");
  }

  $report_secs = $e_sec - $s_sec;
  $report_days = int($report_secs / (60*60*24));
  #$max_days     = 180; 
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   &msg("Signal=$Signal"); 
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str4="<h3>Insufficient or Missing Information:<hr></h3>";
   $html_str=$str.$str1.$str1.$str4;
   print "$html_str\n";
   print "<h4>Please correct the following:</h4>";
   print "<p>\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}

#-----------------------------------------------------------------------------
sub lookupDL
#-----------------------------------------------------------------------------
{
  my $thisserver = $_[0];
  my $thisdl = "???"; 

  if (length($thisserver) <= 16)
  {
    $zwhere = "ss_hostname like '${thisserver}%'"; 
  }
  else
  {
    $zwhere = "ss_hostname = '${thisserver}'"; 
  }

  $sql  = "
    select
      ss_priority
    from
      dbamon.star_servers
    where
      $zwhere
  ";
  ##&msg("DEBUG - sql=$sql"); 
  $star_debug .= "sql=($sql)\n"; 

  $sth2 = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

  while (@Data = $sth2->fetchrow_array)
  {
    $thisdl = $Data[0];
    $star_debug .= "Found\n"; 
  }

  if    ($thisdl eq "Gold")   { $thisdl = "1-Gold"; }
  elsif ($thisdl eq "Silver") { $thisdl = "2-Silver"; }
  elsif ($thisdl eq "Bronze") { $thisdl = "3-Bronze"; }
  elsif ($thisdl eq "Copper") { $thisdl = "4-Copper"; }
  elsif ($thisdl eq "???")
  { 
    $star_entry_missing .= "STAR Server Missing: thisserver=$thisserver\n" if $star_entry_missing !~ /thisserver=$thisserver/; 
    $star_debug .= "thisserver=$thisserver NOT Found\n"; 
    $thisdl = "?"; 
  }
  else                        
  { 
    $star_entry_missing .= "STAR Invalid Delivery Level: thisdl=($thisdl) thisserver=$thisserver\n" if $star_entry_missing !~ /thisserver=$thisserver/; 
    $thisdl = "?"; 
  }

  return $thisdl; 
}

#-----------------------------------------------------------------------------
sub totalBckDet
#-----------------------------------------------------------------------------
{
  $tot_all = $tot_ok + $tot_ng;
  $pct_ok = sprintf("%.2f",($tot_ok / ($tot_all)) * 100) if $tot_all > 0;

  if    ($pct_ok >= 98.5) { $c = "green"; }
  elsif ($pct_ok >= 95) { $c = "yellow"; }
  else                  { $c = "red"; }

  $zwidth = $pct_ok; 

  $bg = &bg;
  print "<tr $bg>
    <td>            <b><font size=2>$last_title
    <td align=right bgcolor=pink><b><font size=2>$tot_ng
    <td align=right bgcolor=lime><b><font size=2>$tot_ok
    <td align=right><b><font size=2>$tot_all
    <td align=right><b><font size=2>${pct_ok}%
    <td><img src='/dbamon/img/$c.gif' height=15 width=$zwidth>
  ";

   $gt_ok += $tot_ok; 
   $gt_ng += $tot_ng; 
   $gt_count++; 

   $tot_ok = 0;
   $tot_ng = 0;
}

#-----------------------------------------------------------------------------
sub report_BckDet
#-----------------------------------------------------------------------------
{
  $in_dl = $arg1;
  &msg("Report BckDet - in_dl=$in_dl");
 
  $sql  = "select
      system,
      instance,
      tool,
      case
	when tool = 'mssql_backup' then data3 
	else data1 
      end ,
      decode(rc,
        0, 'OK',
           'NG' ),
      count(*)
    from
      dbatools.events_global
    where 
      tool in 
      (
        $backup_tools_list
      ) 
      and ts between 
        to_date('${s_date}','YYYY/MM/DD-HH24:MI:SS') and 
        to_date('${e_date}','YYYY/MM/DD-HH24:MI:SS') 
    group by
      system, 
      instance,
      tool,
      case
	when tool = 'mssql_backup' then data3 
	else data1 
      end ,
      rc 
    order by
      1, 2, 3, 4, 5
  ";

  ##&msg("DEBUG - sql=$sql"); 

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $count = 0;
  $tot_ok = 0;
  $tot_ng = 0;

  print "<p><center>
    <font size=4>DB Backup Success - All DBMS's - Delivery Level $in_dl
    <br><font size=4>Report Date Range: $s_date Through $e_date</font> ($report_days Days)
    <p><table border=0> 
    <tr bgcolor=slate>
    <th><font size=2>Server / Instance - Backup Tool / Backup Type
    <th><font size=2>NG<br>Backups
    <th><font size=2>OK<br>Backups
    <th><font size=2>Total<br>Backups
    <th colspan=2><font size=2>% Successful
    </tr>
  ";

  while (@Data = $sth->fetchrow_array)
  {
    $system   = $Data[0];
    $instance = $Data[1];
    $tool     = $Data[2];
    $type     = $Data[3];
    $rc       = $Data[4];
    $count    = $Data[5];

    if ($tool eq "mssql_backup")
    {
      $instance = "MSSQL"; 
    }

    $system =~ s/ //g;

    $type = "ARC*" if $type =~ /^ARC/;
    $type = "DF*"  if $type =~ /^DF/;

    $title = "$system/${instance}-$tool/$type"; 
    $title =~ s/ //g;

    $dl = &lookupDL($system); 

    next if $dl eq "?";
    next if $dl ne $in_dl;

    #---- Debug line
    print "<tr bgcolor=yellow><td colspan=10>$fs DEBUG - system=$system in=$instance tool=$tool type=$type dl=$dl rc=$rc count=$count" if $debug_bck; 

    if ($last_title ne "" && $title ne $last_title) { &totalBckDet; }

    if ($rc eq "OK") { $tot_ok += $count; }
    else             { $tot_ng += $count; }

    $last_title = $title; 
  }

  &totalBckDet; 

  #---- Total line
  $gt_all = $gt_ok + $gt_ng;
  $pct_ok = sprintf("%.2f",($gt_ok / ($gt_all)) * 100) if $gt_all > 0;

  if    ($pct_ok >= 98.5) { $c = "green"; }
  elsif ($pct_ok >= 95)   { $c = "yellow"; }
  else                    { $c = "red"; }

  $zwidth = $pct_ok; 
  print "<tr bgcolor=slate>
    <td>            <b><font size=2>Total ($gt_count Instances):
    <td align=right><b><font size=2>$gt_ng
    <td align=right><b><font size=2>$gt_ok
    <td align=right><b><font size=2>$gt_all
    <td align=right><b><font size=2>${pct_ok}%
    <td><img src='/dbamon/img/$c.gif' height=15 width=$zwidth>
  ";

  print "</table></center><hr> \n";

  if ($star_entry_missing)
  {
    &msg("Servers with missing or invalid STAR delivery level data:"); 
    print "<pre><font size=2>$star_entry_missing</pre>"; 

    #&msg("lookupDL Debugging Info:"); 
    #print "<pre><font size=2>$star_debug</pre>"; 
  }
}

#-----------------------------------------------------------------------------
sub createReportBackup
#-----------------------------------------------------------------------------
{
  &msg("Creating Backup Report");
  $sql  = "select
      system,
      decode(rc,
        0, 'OK',
           'NG' ),
      count(*)
    from
      dbatools.events_global
    where 
      tool in 
      (
        $backup_tools_list
      ) 
      and ts between 
        to_date('${s_date}','YYYY/MM/DD-HH24:MI:SS') and 
        to_date('${e_date}','YYYY/MM/DD-HH24:MI:SS') 
    group by
      system, 
      rc ";

  ##&msg("DEBUG - sql=$sql"); 

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $count = 0;

  print "<p><center>
    <font size=4>DB Backup Success - All DBMS's
    <br><font size=4>Report Date Range: $s_date Through $e_date</font> ($report_days Days)
    <p><table border=0> 
    <tr bgcolor=slate>
    <th><font size=2>Delivery<br> Level
    <th><font size=2>NG<br>Backups
    <th><font size=2>OK<br>Backups
    <th><font size=2>Total<br>Backups
    <th><font size=2>% Successful
    </tr>
  ";

  while (@Data = $sth->fetchrow_array)
  {
    $system = shift @Data;
    $rc     = shift @Data;
    $count  = shift @Data;

    $system =~ s/ //g;

    $dl = &lookupDL($system); 

    next if $dl eq "?";

    ##&msg("DEBUG - system=$system dl=$dl rc=$rc count=$count"); 

    if ($rc eq "OK") { $tot_backups_ok{$dl} += $count; }
    else             { $tot_backups_ng{$dl} += $count; }

    $tot_backups{$dl} += $count;
  }

  foreach $thisdl (sort keys %tot_backups)
  {
    $pct_ok = sprintf("%.2f",($tot_backups_ok{$thisdl} / $tot_backups{$thisdl} * 100)) if $tot_backups{$thisdl};
    $bg = &bg;
    print "<tr $bg>
      <td>            <b><font size=2><a href='http://$fqhostname/cgi-bin/dbamon_sla_report.pl?BckDet,$thisdl,$s_date,$e_date,$report_days'>$thisdl</a>
      <td align=right><b><font size=2>$tot_backups_ng{$thisdl} 
      <td align=right><b><font size=2>$tot_backups_ok{$thisdl} 
      <td align=right><b><font size=2>$tot_backups{$thisdl} 
      <td align=right><b><font size=2>${pct_ok}%
    </tr>
    ";

    $gt_backups    += $tot_backups{$thisdl};
    $gt_backups_ng += $tot_backups_ng{$thisdl};
    $gt_backups_ok += $tot_backups_ok{$thisdl};
  }

  $pct_ok = sprintf("%.2f",($gt_backups_ok / $gt_backups * 100)) if $gt_backups;
  print "<tr bgcolor=slate>
    <td>            <b><font size=2>Total:
    <td align=right><b><font size=2>$gt_backups_ng
    <td align=right><b><font size=2>$gt_backups_ok
    <td align=right><b><font size=2>$gt_backups
    <td align=right><b><font size=2>${pct_ok}%
  ";

  print "</table></center><hr> \n";
}

#-----------------------------------------------------------------------------
sub createReportUptime
#-----------------------------------------------------------------------------
{
  &msg("Creating Uptime Report");
  &msg("Checking DBAmon task status");
  return if &checkTasks == 1; 

  $sleeptime = 5;
  $sleepcnt  = 1;  
  $count_hwm = 0; 

  &msg("Checking DBAmon Repository for consistency");
  while  ( &checkDB == 1) 
  {
    sleep $sleeptime;
    $sleepcnt++; 
  } 

  $sql  = "select
      decode(sd.id8,
        'Gold',   '1-Gold',
        'Silver', '2-Silver',
        'Bronze', '3-Bronze',
        'Copper', '4-Copper',
        sd.id8
        ),
      instance,
      count(*), 
      sum(tot_downtime),
      avg(tot_pct)
    from
      dbamon.uptime_summary us,
      dbamon.summary_detail sd
    where 
      sd.dbamonmode like 'prod%'
      and us.instance = sd.title
      and us_sby_flag not in ('Y','R','P')
      and (id3 is null or id3 not in ($exclude_id3_list))
      and us.ts between 
        to_date('${s_date}','YYYY/MM/DD-HH24:MI:SS') and 
        to_date('${e_date}','YYYY/MM/DD-HH24:MI:SS') 
      ${dbms_comment}and dbms = 'OracleDB-UX'
      and us.instance not in ($uptime_db_exclude)
    group by
      sd.id8,
      instance
    order by
      1, 2";

  ##&msg("DEBUG - sql=$sql"); 

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $count = 0;

  print "<center><p>
    <font size=4>DB Availability 
    <br><font size=4>Report Date Range: $s_date Through $e_date</font> ($report_days Days)
    <p><table border=0> 
    <tr bgcolor=slate>
    <th><font size=2>Delivery<br> Level
    <th><font size=2>SLA<br> Uptime % 
    <th><font size=2>Compliant<br> Instances
    <th><font size=2>Non<br>Compliant<br> Instances
    <th><font size=2>Total<br> Instances
    <th><font size=2>%<br>Instances<br> Compliant 
    <th><font size=2>Instance<br>Average<br>Uptime<br>% 
  \n";

  $instance = ""; 
  $tot_downtime = ""; 

  while (@Data = $sth->fetchrow_array)
  {
    $delivery_level = shift @Data;
    $instance       = shift @Data;
    $count          = shift @Data;
    $tot_downtime   = shift @Data;
    $avg_pct        = shift @Data;

    next if $delivery_level eq "?";

    #---- debug
    ##print "<tr><td>$instance\n" if $delivery_level =~ /Gold/;

    if ($last_delivery_level && $delivery_level ne $last_delivery_level)
    {
      &totalDL;
    }

    #---- Test compliance
    if    ($delivery_level eq "1-Gold")   { $sla = 99.5; }
    elsif ($delivery_level eq "2-Silver") { $sla = 99; }
    elsif ($delivery_level eq "3-Bronze") { $sla = 98; }
    else { $sla = "N/A"; }

    if    ($sla eq "N/A")    { $compliant = 1; $color = "blue"; }
    elsif ($avg_pct >= $sla) { $compliant = 1; $color = "green"; }
    else                     { $compliant = 0; $color = "red"; }

    #&msg("DEBUG - dl=$delivery_level instance=$instance count =$count td=$tot_downtime ap=$avg_pct compliant=$compliant"); 
    #&msg("        tot_compliant=$tot_compliant tot_instances=$tot_instances"); 

    if ($sla eq "N/A") { $sla_out = $sla; }
    else               { $sla_out = ">= ${sla}%"; }

    $last_delivery_level = $delivery_level;
    $tot_compliant++ if $compliant; 
    $tot_instances++; 
    $tot_avg_pct += $avg_pct;
  }

  #---- Last value
  &totalDL;

  #---- Total line
  $pct_compliant = sprintf("%.2f",($gt_compliant / $gt_instances) * 100) if $gt_instances > 0;

  print "<tr bgcolor=slate>
    <td>            <b><font size=2>Total: 
    <td>            <b><font size=2>&nbsp; 
    <td align=right><b><font size=2>$gt_compliant
    <td align=right><b><font size=2>$gt_instances
    <td align=right><b><font size=2>${pct_compliant}%
    \n";

  print "</table></center><hr> \n";
}

#-----------------------------------------------------------------------------
sub report_UptDet
#-----------------------------------------------------------------------------
{
  $dl = substr($arg1,2);
  &msg("Report UptDet - dl=$dl");

  &msg("Creating Uptime Report");
  &msg("Checking DBAmon task status");
  return if &checkTasks == 1; 

  $sleeptime = 5;
  $sleepcnt  = 1;  
  $count_hwm = 0; 

  &msg("Checking DBAmon Repository for consistency");
  while  ( &checkDB == 1) 
  {
    sleep $sleeptime;
    $sleepcnt++; 
  } 

  $sql = "select
      instance,
      dbms,
      count(*),
      sum(tot_downtime),
      avg(tot_pct)
    from
      dbamon.uptime_summary us,
      dbamon.summary_detail sd
    where 
      sd.dbamonmode like 'prod%'
      and us.instance = sd.title
      and us_sby_flag not in ('Y','R','P')
      and (id3 is null or id3 not in ($exclude_id3_list))
      and us.ts between 
        to_date('${s_date}','YYYY/MM/DD-HH24:MI:SS') and 
        to_date('${e_date}','YYYY/MM/DD-HH24:MI:SS') 
      and id8 = '$dl'
      ${dbms_comment}and dbms = 'OracleDB-UX'
      and us.instance not in ($uptime_db_exclude)
    group by
      instance,
      dbms
    order by
      1
  ";

  ##&msg("DEBUG - sql=$sql"); 

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $count = 0;

  print "<center><p>
    <font size=4>DB Availability - Delivery Level $dl
    <br><font size=4>Report Date Range: $s_date Through $e_date</font> ($report_days Days)
    <p><table border=0> 
    <tr bgcolor=slate>
    <th><font size=2>Server:Instance 
    <th><font size=2>DBMS
    <th><font size=2>Downtime<br> (Hours)
    <th><font size=2>SLA<br> Uptime % <br>Requirement
    <th><font size=2>Uptime<br> % 
    <th colspan=2><font size=2>Reports
  \n";

  $instance = ""; 
  $tot_downtime = ""; 

  while (@Data = $sth->fetchrow_array)
  {
    $instance       = shift @Data;
    $dbms           = shift @Data;
    $count          = shift @Data;
    $tot_downtime   = shift @Data;
    $avg_pct        = shift @Data;

    $gt_pct += $avg_pct;
    $gt_cnt ++; 

    $avg_pct = sprintf("%.2f",$avg_pct); 
    $tot_downtime_hours = sprintf("%.2f",$tot_downtime / 3600); 

    #---- debug
    ##print "<tr><td>$instance\n" if $delivery_level =~ /Gold/;
    #if ($last_delivery_level && $delivery_level ne $last_delivery_level)
    #{
    #  &totalDL;
    #}

    #---- Test compliance
    if    ($dl eq "Gold")   { $sla = 99.5; }
    elsif ($dl eq "Silver") { $sla = 99; }
    elsif ($dl eq "Bronze") { $sla = 98; }
    else { $sla = "N/A"; }

    if    ($sla eq "N/A")    { $compliant = 1; $color = "blue"; }
    elsif ($avg_pct >= $sla) { $compliant = 1; $color = "lime"; }
    else                     { $compliant = 0; $color = "pink"; }

    #&msg("DEBUG - dl=$delivery_level instance=$instance count =$count td=$tot_downtime ap=$avg_pct compliant=$compliant"); 
    #&msg("        tot_compliant=$tot_compliant tot_instances=$tot_instances"); 

    if ($sla eq "N/A") { $sla_out = $sla; }
    else               { $sla_out = ">= ${sla}%"; }

    $bg = &bg;
    print "<tr $bg>
      <td>            <b><font size=2>$instance
      <td>            <b><font size=2>$dbms
      <td align=right><b><font size=2>$tot_downtime_hours
      <td align=right><b><font size=2>$sla_out
      <td align=right bgcolor=$color><b><font size=2>${avg_pct}%
      <td align=right><b><font size=2><a href='http://$fqhostname/cgi-bin/dbamon_rpt.pl?prod,uptime5,$instance'>Drill Down (Summary)
      <td align=right><b><font size=2><a href='http://$fqhostname/cgi-bin/dbamon_rpt.pl?prod,uptime4,$instance'>Raw Data (Detail)
      \n";

    $tot_compliant++ if $compliant; 
    $tot_instances++; 
  }

  #---- Total line
  $pct_compliant = sprintf("%.2f",($gt_pct / $gt_cnt));

  print "<tr bgcolor=slate>
    <td>            <b><font size=2>Total ($gt_cnt Instances): 
    <td>            <b><font size=2>&nbsp; 
    <td>            <b><font size=2>&nbsp; 
    <td>            <b><font size=2>&nbsp; 
    <td align=right><b><font size=2>Average: ${pct_compliant}%
    \n";

  print "</table></center><hr> \n";
}

#-----------------------------------------------------------------------------
sub checkDT
#-----------------------------------------------------------------------------
{
  my $in_key = $_[0];

  $dtprevent = "";
  $dtdesc    = "";

  $dtfile = "/opt/dbamon/adm/downtime/dt_${in_key}.txt";
  return if ! -e "$dtfile";
  open(DT,"$dtfile") || &error("Cannot open $dtfile = $!");
  while(<DT>)
  {
    next if /^#/;
    if (/^Prevent: /)
    {
      $dtprevent = substr($_,11);
    }
    if (/^Desc: /)
    {
      $dtdesc = substr($_,11);
    }
  }
  close(DT);
}

#-----------------------------------------------------------------------------
sub report_Review
#-----------------------------------------------------------------------------
{
  &msg("Report Review arg1=$arg1");

  #---- Verify

  &msg("Creating Uptime Report");
  &msg("Checking DBAmon task status");
  return if &checkTasks == 1; 

  $sleeptime = 5;
  $sleepcnt  = 1;  
  $count_hwm = 0; 

  &msg("Checking DBAmon Repository for consistency");
  while  ( &checkDB == 1) 
  {
    sleep $sleeptime;
    $sleepcnt++; 
  } 

  #---- Report REVIEW

  &msg("Selecting DBAMON.UPTIME_SUMMARY rows where TOT_PCT < 100");
  $sql = "select
      to_char(tot_date,'YYYY/MM/DD'),
      instance,
      id8,
      dbms,
      us_key,
      tot_time,
      tot_downtime,
      tot_pct,
      us_sby_flag,
      to_char(sd.ts,'YYYY/MM/DD-HH24:MI:SS')
    from
      dbamon.uptime_summary us,
      dbamon.summary_detail sd
    where 
      sd.dbamonmode like 'prod%'
      and us.instance = sd.title
      and us_sby_flag not in ('Y','R')
      and (id3 is null or id3 not in ($exclude_id3_list))
      ${dbms_comment}and dbms = 'OracleDB-UX'
      and us.instance not in ($uptime_db_exclude)
      and tot_pct < 100
      and us_key is not null
      AND sd.ts > (sysdate - 90)
    order by
      1 desc, 2
  ";

  ##&msg("DEBUG - sql=$sql"); 

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $count = 0;

  print "<p> <font size=4>DB Downtime Review 
    <p><table border=0> 
    <tr bgcolor=slate>
      <th><font size=2>Deliver<br>Level
      <th><font size=2>Downtime<br>Date
      <th><font size=2>Downtime<br>Key
      <th><font size=2>Instance
      <th><font size=2>DBMS
      <th><font size=2>Total<br>Time
      <th><font size=2>Down<br>Time
      <th><font size=2>Uptime<br>%
      <th><font size=2>Sby<br>Flag
      <th><font size=2>Row<br>Timestamp
      <th colspan=2><font size=2>Links
  \n";

  $instance = ""; 
  $tot_downtime = ""; 

  $last_date = ""; 
  $tot_done = 0;
  $tot_undone = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $tot_date     = shift @Data;
    $instance     = shift @Data;
    $dl           = shift @Data;
    $dbms         = shift @Data;
    $key          = shift @Data;
    $tot_time     = shift @Data;
    $tot_downtime = shift @Data;
    $tot_pct      = shift @Data;
    $us_sby_flag  = shift @Data;
    $ts           = shift @Data;

    $tot_downtime_hours = sprintf("%.2f",$tot_downtime / 3600); 
    $tot_time_hours = sprintf("%.2f",$tot_time / 3600); 

    #---- debug
    ##print "<tr><td>$instance\n" if $delivery_level =~ /Gold/;
    #if ($last_delivery_level && $delivery_level ne $last_delivery_level)
    #{
    #  &totalDL;
    #}

    #&msg("DEBUG - dl=$delivery_level instance=$instance count =$count td=$tot_downtime ap=$avg_pct compliant=$compliant"); 
    #&msg("        tot_compliant=$tot_compliant tot_instances=$tot_instances"); 

    $bg = &bg;

    if    ($dl =~ /Gold/)   { $dl_color= "gold"; }
    elsif ($dl =~ /Silver/) { $dl_color= "silver"; }
    elsif ($dl =~ /Bronze/) { $dl_color= "bronze"; }
    else                    { $dl_color= ""; }
  
    if ($tot_date ne $last_date && $last_date)
    {
      print "<tr bgcolor=slate><td colspan=12><b>$fs $last_date Total - Complete: $tot_done  Total Missing: $tot_undone</b></tr>"; 
      $tot_done = 0;
      $tot_undone = 0;
    }

    $href = "<a href='http://$fqhostname/cgi-bin/dbamon_downtime_edit.pl?$key?go'><b> $key </b></a>";
    $server = (split(/\:/,$instance))[0];
    $server_1st = uc substr($server,0,1); 

    print "<tr $bg>
      <td bgcolor=$dl_color>   <b><font size=2>$dl  
      <td>            <b><font size=2>$tot_date
      <td align=right><b><font size=2>$href
      <td>            <b><font size=2><a href='http://$fqhostname/cgi-bin/dbamon_rpt.pl?prod,uptime4,$instance'>$instance</a>
      <td            ><b><font size=2>$dbms
      <td align=right><b><font size=2>$tot_time_hours
      <td align=right><b><font size=2>$tot_downtime_hours
      <td align=right><b><font size=2>$tot_pct
      <td ><b><font size=2>$us_sby_flag
      <td ><b><font size=2>$ts
      <td>            <b><font size=2><a href='http://$fqhostname/cgi-bin/ticketHubConsole?TicketDetail,Server:$server,DB'>Recent Tickets for Server $server</a>
      <td>            <b><font size=2><a href='http://$fqhostname/dbamon/alpha_prod/$server_1st.html'>DBAmon $server_1st Page</a>
      \n";

    #---- Read DT data
    &checkDT($key); 
    if (! $dtdesc && ! $dtprevent)
    {
      print "<tr $bg><td><td><td><td bgcolor=pink colspan=9>$fs <b>Downtime Description Missing - Click $href To Edit"; 
      $tot_undone++; 
    }
    else
    {
      print "<tr $bg><td><td><td><td colspan=9 bgcolor=#93DB70>$fs <b>Downtime Description: $dtdesc"; 
      print "<tr $bg><td><td><td><td colspan=9 bgcolor=#93DB70>$fs <b>Downtime Prevent: $dtprevent"; 
      $tot_done++; 
    }

    $last_date = $tot_date;
  }

  #---- Total line

  print "</table></center><hr> \n";
}

#-----------------------------------------------------------------------------
sub totalDL
#-----------------------------------------------------------------------------
{
  $pct_compliant = sprintf("%.2f",($tot_compliant / $tot_instances) * 100) if $tot_instances > 0;

  #$zlevel = substr($last_delivery_level,2);
  $zlevel = $last_delivery_level;

  $tot_not_compliant = $tot_instances - $tot_compliant; 

  $pct_uptime = sprintf("%.2f",($tot_avg_pct / $tot_instances)) if $tot_instances > 0;

  if    ($sla_out eq "N/A")              { $sla_color=""; }
  elsif ($pct_compliant >= $sla)         { $sla_color="lime"; }
  elsif ($pct_compliant >= ($sla - 0.5)) { $sla_color="yellow"; }
  else                                   { $sla_color="pink"; }

  if    ($sla_out eq "N/A")           { $avg_color=""; }
  elsif ($pct_uptime >= $sla)         { $avg_color="lime"; }
  elsif ($pct_uptime >= ($sla - 0.5)) { $avg_color="yellow"; }
  else                                { $avg_color="pink"; }

  $bg = &bg;
  print "<tr $bg>
    <td>            <b><font size=2><a href='http://$fqhostname/cgi-bin/dbamon_sla_report.pl?UptDet,$zlevel,$s_date,$e_date,$report_days'>$zlevel</a>
    <td>            <b><font size=2>$sla_out
    <td align=right><b><font size=2>$tot_compliant
    <td align=right><b><font size=2>$tot_not_compliant
    <td align=right><b><font size=2>$tot_instances
    <td align=right bgcolor=$sla_color><b><font size=2>${pct_compliant}%
    <td align=right bgcolor=$avg_color><b><font size=2>${pct_uptime}%
    \n";

   $gt_instances += $tot_instances; 
   $gt_compliant += $tot_compliant; 

   $tot_instances = 0;
   $tot_compliant = 0;
   $tot_avg_pct   = 0; 

   $zlevel_short = substr($zlevel,2); 

   $report_string .= "$zlevel_short=${pct_compliant}%/${sla}% " if substr($zlevel,0,1) < 4 && $zlevel !~ /Standard/;
   $color_string  .= "${sla_color} " if substr($zlevel,0,1) < 4 && $zlevel !~ /Standard/;
}

#-----------------------------------------------------------------------------
sub checkTasks
#-----------------------------------------------------------------------------
{
  # See if all tasks have completed the first iteration - if not, then die

  $statement  = "
    select
      dbamonmode,
      max(iter_num),
      avg(iter_dur)
    from
      dbamon.task
    where
      dbamonmode like 'prod%'
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $tasks_starting = 0;
  $tasks_count    = 0;

  $i_mode   = ""; 
  $avg_iter = ""; 

  while (@Data = $sth->fetchrow_array)
  {
    $tasks_count++;
    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    ##print "task=$i_mode maxiter=$i_num\n";

    if ($i_num < 1)
    {
      $taskflag3 = 1;
      $tasks_starting++;
    }
  }

  if ($taskflag3)
  {
    &msg("<font color=darkred>DBAmon is now in the process of restarting after an outage - $tasks_starting/$tasks_count Tasks Starting - taskflag3=$taskflag3 tasks_count=$tasks_count tasks_starting=$tasks_starting</font>");
    &msg("<font color=darkred>DBAmon is rarely restarted, but this report cannot be created until the DBAmon restart is complete - Please try again later (within 1 hour)</font>");
    return 1;
  }
}

#-----------------------------------------------------------------------------
sub checkDB
#-----------------------------------------------------------------------------
{
  $checkdb_debug = 0;

  $sql  = "
    select
      count(*) 
    from
      dbamon.instances
    where
      dbamonmode like 'prod%'
      and dbms != '(ServerAlias)'
  ";
  &msg("DEBUG - sql=$sql") if $checkdb_debug; 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_detail_instances = $Data[0];
  }
  &msg("DEBUG -There are $num_detail_instances instances from dbamon.instances") if $checkdb_debug;

  $count_hwm = $num_detail_instances if $num_detail_instances > $count_hwm; 

  # Now count the number of rows in the tasks table for iteration 0.
  # If the number of detail rows != the sum from the summary_dbms table,
  # then an update must be happening now!

  $sql  = "
    select
      sum(count)
    from
      dbamon.summary_dbms
    where
      dbamonmode like 'prod%'
    ";
  &msg("DEBUG - sql=$sql") if $checkdb_debug; 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_dbms_instances = $Data[0];
  }
  &msg("DEBUG - There are $num_dbms_instances instances from the dbamon.summary_dbms table") if $checkdb_debug;

  $count_hwm = $num_dbms_instances if $num_dbms_instances > $count_hwm; 

  if ($num_detail_instances != $num_dbms_instances ||
      $num_detail_instances != $count_hwm ||
      $num_dbms_instances != $count_hwm)
  {
    &msg("<font color=darkred><u>DBAmon DB is being updated - $num_detail_instances/$num_dbms_instances/$count_hwm - Sleeping $sleeptime seconds - Please wait... ($sleepcnt)</u></font>");
    return 1;
  }
  &msg("DBAmon DB is consistent - $num_detail_instances/$num_dbms_instances/$count_hwm");
  return 0;
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    #return "bgcolor=white";
    return "bgcolor=#f5f5f5";
  }
  else
  {
    $lastbg = 1;
    #return "bgcolor=lightgrey";
    return "bgcolor=#E6E6FA";
  }
}

#-----------------------------------------------------------------------------
sub createForm
#-----------------------------------------------------------------------------
{
  $sec = 0; 
  $min = 0; 
  $hour = 0; 
  ($sec,$min,$hour,$mday,$mon,$year)=localtime(time());
  $year += 1900;
  $mon++;

  #print "<form method='POST' action='/cgi-bin/dbamon_sla_report.pl'>";
  print "<form method='GET' action='/cgi-bin/dbamon_sla_report.pl'>";
  print " <font size=2><p>
    Choose the Reporting Period Start and End dates, then click <b>Create Report</b>. 
    <p>
    <hr>
    <form> 
    <table>
    <tr bgcolor=slate><th><th><h5>Year<th><h5>Month<th><h5>Day</tr>\n";

  #
  # Process Start Date    
  #
  print "
  <tr>
  <td><B><font size=2>Reporting Period Start Date-Hour:</b>
  <td><select name=s_yyyy>\n";
  for (2000..2099)
  {
    if ($_ == $year) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=s_mm>\n";
  for (01..12)
  {
    if ($_ == $mon) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=s_dd>\n";
  for (01..31)
  {
    if ($_ == $mday) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print " </select>\n";

  #
  # Process End Date    
  #

  print "
  <tr>
  <td><B><font size=2>Reporting Period End Date-Hour:</b>
  <td><select name=e_yyyy>\n";
  for (2000..2099)
  {
    if ($_ == $year) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=e_mm>\n";
  for (01..12)
  {
    if ($_ == $mon) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=e_dd>\n";
  for (01..31)
  {
    if ($_ == $mday) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print " </select>
  </table>

  <p>
  <b><INPUT type=submit value=\"Create Report \"></input></b>
  <hr>
  <INPUT TYPE=HIDDEN NAME=process_flag value=\"Y\">
  </CENTER></form>
  <!--#include virtual=\"/dba/misc/foot.html\"-->
  ";
}

#-----------------------------------------------------------------------------
sub connectDB
#-----------------------------------------------------------------------------
{
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
     &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  #---- Attempt to make sure that no meta characters are entered in the form.
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub updateOverrides
#-----------------------------------------------------------------------------
{
  &msg("Processing DB downtime overrides"); 
  $dtdir = "/opt/dbamon/adm/downtime"; 

  opendir(DT_DIR, "$dtdir") || &error_msg("Cannot opendir $dtdir - $!");
  @dt_files = sort readdir DT_DIR;
  closedir(DT_DIR);

  $ovdebug = 0;
  $dt_prevent = ""; 
  $dt_count = 0; 
  $dt_updates = 0; 

  DTFILE: foreach $dt_file (@dt_files)
  {
    if ($dt_file =~ /^dt_/)
    {
      $dt_count++;

      $dt_key = $dt_file;
      $dt_key =~ s/^dt_//;
      $dt_key =~ s/.txt//;

      chop($dt_prevent = `grep '^Prevent:' $dtdir/$dt_file | awk '{ print \$2 }'`); 

      &msg("DEBUG Found DT dt_file=$dt_file dt_key=$dt_key dt_prevent=$dt_prevent") if $ovdebug; 

      if ($dt_prevent eq "Y") 
      {
        $us_sby_flag = "P"; 
      }
      else
      {
        $us_sby_flag = ""; 
      }

      if ($us_sby_flag)
      {
        &msg("DEBUG Updating DBAMON.DOWNTIME_SUMMARY key=$dt_key column US_SBY_FLAG=$us_sby_flag") if $ovdebug;
        $sql = "update
          dbamon.uptime_summary
        set
          us_sby_flag = '$us_sby_flag'
        where
          us_key = $dt_key 
        ";
        &msg("DEBUG - sql=$sql") if $ovdebug;
        $sth = $dbh->prepare($sql) || &error('update_override');
        $sth->execute || &error('execute_override');
  
        $dt_updates++;
      }
    }
  }
  &msg("Done - dt_count=$dt_count dt_updates=$dt_updates"); 
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

#---- Prepare tmp dir 
system("mkdir /tmp/DBAmon 2>/dev/null"); 
system("chmod 777 /tmp/DBAmon 2>/dev/null"); 

#$zclient = $ENV{'REMOTE_HOST'};
#system("echo '' | mailx -s 'monitor--$P zclient=$zclient' border\@thecompany.com");

print "Content-type: text/html\n\n
  <title>DBAmon SLA Reporting</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750>
    <tr bgcolor=darkblue><td><center><font color=white size=9>DBAmon</font></center>
    <tr bgcolor=wheat><td><font face=$font size=5>
      <center>DBAmon SLA Reporting</center>
  </table>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>
 $links_include
</table>
<hr>
<font size=2>
";

#---- Get form data
&get_request;

$args    = (split(/\?/,$ARGV[0]))[0];
$verb    = (split(/\,/,$args))[0];
$arg1    = (split(/\,/,$args))[1];
$arg2    = (split(/\,/,$args))[2];
$arg3    = (split(/\,/,$args))[3];
$arg4    = (split(/\,/,$args))[4];

$arg0    = $ARGV[0];

$process_flag = $rqpairs{'process_flag'}; 

&msg("DEBUG verb=$verb arg0=$arg0 arg1=$arg1 arg2=$arg2"); 

if ($verb eq "BatchRpt1") 
{ 
  $s_date = $arg1;
  $e_date = $arg2;
}

if ($verb eq "BckDet") 
{ 
  &connectDB; 
  $s_date = $arg2;
  $e_date = $arg3;
  &msg("Reporting timestamp range: $s_date - $e_date"); 
  $report_days = $arg4;
  &report_BckDet; 
}
elsif ($verb eq "Review") 
{ 
  &connectDB; 
  &report_Review; 
}
elsif ($verb eq "UptDet") 
{ 
  &connectDB; 

  #---- Update uptime_summary rows from overrides
  &updateOverrides;

  $s_date = $arg2;
  $e_date = $arg3;
  &msg("Reporting timestamp range: $s_date - $e_date"); 
  $report_days = $arg4;
  &report_UptDet; 
}
elsif ($process_flag eq "Y" || $verb eq "BatchRpt1")
{
  if ($verb ne "BatchRpt1")
  {
    &error_check;
    if (@error_list != 0)
    {
      &error_html;
      exit 1;
    }
  }
 
  #----- Create SLA report
  &connectDB; 

  #---- Update uptime_summary rows from overrides
  &updateOverrides;

  #---- Calc report_days if it is missing
  if ($s_date && $e_date && ! $report_days)
  {
    $report_days = int((&timeToNum($e_date) - &timeToNum($s_date)) / (24*60*60)); 
    &msg("report_days Calculated $report_days"); 
  }

  &msg("Reporting timestamp range: $s_date - $e_date"); 
  &createReportBackup;
  &createReportUptime;

  system("rm -f /tmp/${P}_rpt.txt");
  system("echo '($report_string)' > /tmp/${P}_rpt.txt");
  system("rm -f /tmp/${P}_colors.txt");
  $color_string =~ s/lime/Green/g;
  $color_string =~ s/yellow/Yellow/g;
  $color_string =~ s/pink/Red/g;
  system("echo '($color_string)' > /tmp/${P}_colors.txt");
}
else
{
  &createForm;
}

&msg("Done"); 
exit 0;
