#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools";
#-------------------------------------------------------------------------
#    Name:  dbamon_tickets.pl
#-------------------------------------------------------------------------

$| = 1;
$P = "dbamon_tickets.pl";
require "cgi_handlers.pl";

$maxrows       = 500;
$days          = 14; 

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#---- Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

chop($date     = `date`);
chop($host     = `hostname`);
#---- Save Company name
$compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'` if -e '/etc/resolv.conf';
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];

$database = "dbamon";

#---- See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#-------------------------------------------------------------------------
#
# Subs
#
#-------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=white";
  }
  else
  {
    $lastbg = 1;
    #return "bgcolor=lightgrey";
    return "bgcolor=#dcdcdc";
    #return "bgcolor=palegoldenrod";
  }
}

#-----------------------------------------------------------------------------
sub displayError {
#-----------------------------------------------------------------------------
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body><font face=$font>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $sql";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  $s_time = time;

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "O") 
  {
    $sql  = "
      select 
	to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
	instance, 
	system, 
	sev, 
	text,
	paged,
	ticket
      from 
	dbamon.events 
      where 
	ts >= (sysdate - $days)
	and sev = 'C'
        and ticket = 'Y'      
      order by ts desc
    ";
  }
  else
  {
    $sql  = "
      select 
	--to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
	dbamon.dateconvert_19(ts), 
	instance, 
	system, 
	sev, 
	text,
	paged,
	ticket
      from 
	dbamon.events 
      where 
	--ts >= (sysdate - 1)
        datediff(day,ts,getdate()) <= $days 
	and sev = 'C'
        and ticket = 'Y'      
      order by ts desc
    ";
  }
  ##print "$sql\n";

  $sth = $dbh->prepare($sql) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  &msg("Executing Query = sql=$sql"); 
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;
  &msg("Query elapsed time: $elapsed second(s) - Building dynamic html table"); 
  print "<hr>\n";

  print "<table border=3 width=98% >\n";
  print "<tr bgcolor=slate>
    <th> <span $style_normal>Ticket<br>Creation<br>Timestamp
    <th> <span $style_normal>Instance
    <th> <span $style_normal>DBAmon<br>MsgId
    <th> <span $style_normal>Event<br>Text
    <th> <span $style_normal>Ticketed?
    <th> <span $style_normal>Server<br>Name
    <th> <span $style_normal>Event<br>Severity
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = $Data[0];
    $in    = $Data[1];
    $sy    = $Data[2];
    $sev   = $Data[3];
    $text  = $Data[4];
    $paged = $Data[5];
    $ticket= $Data[6];

    $paged = "N" if $paged eq ""; 

    $selectcount++;
     
    $color = "white";
    if ($sev eq "C") { $color = "pink";   $fcolor = "black"}
    if ($sev eq "W") { $color = "yellow"; $fcolor = "black"}
    if ($sev eq "I") { $color = "cyan";   $fcolor = "black" }
    if ($sev eq "U") { $color = "lime";   $fcolor = "black"}

    if ($company eq "thecompany" && length($ticket) > 1) 
    {
      $ticket_url = "<b><a href='blt_lookup.pl?$ticket'>$ticket</a>";
    }
    else
    {
      $ticket_url = $ticket;
    }

    $msgid = (split(/ /,$text)) [0];
    $msgid_short = substr($msgid,0,6);
    $msgid_url = "<a href='http://dbamon.com/errors/index.shtml#$msgid'>$msgid_short</a>";

    $in_url = "<b><a href='dbamon_hist.pl?$in'>$in</a>";

    $text_fixed = substr($text,7); 

    $fs = "2 face=$font";

    $bg = &bg;
    print "<tr $bg>
      <td nowrap><font size=$fs color=$fcolor>$ts</font>
      <td nowrap><font size=$fs color=$fcolor>$in_url</font>
      <td bgcolor=pink><font size=$fs color=$fcolor><b>$msgid_url</font></b>
      <td bgcolor=pink><b><font size=$fs color=$fcolor>$text_fixed</font>
      <td nowrap><font size=$fs color=$fcolor><b>$ticket_url / $paged</font>
      <td><font size=$fs color=$fcolor>$sy</font>
      <td bgcolor=pink font size=$fs color=$fcolor>$sev</font></font>
    \n";

  }

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><font size=$fs><b>No ticket history data found (for the last $days days)\n";
  }
  print "</table>\n";
  print "<hr><i>Rows Selected: $selectcount</i>\n";
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

sub custom_html {

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#------------------------------------------------------------------------------
sub CheckForEvilness
#------------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-------------------------------------------------------------------------
#
# Main
#
#-------------------------------------------------------------------------

$logfile = "/tmp/dbamon_hist.log";
unlink($logfile);
chop($CurrentDate = `date`);

system("echo '' | mailx -s 'monitor--$P ($ENV{'REMOTE_HOST'}) [AUTO]' border\@dba.it.thecompany.com");

&get_request;

@words = split(/,/,$ARGV[0]);
$instance = $words[0];
$prodtest = $words[1];

if ($prodtest eq "test")
{
  $db = "dbamon_test";
}
else
{
  $db = "dbamon";
}

open(LOG, ">>$logfile" );
print LOG "$CurrentDate - $P dbms=$dbms prodtest=$prodtest\n";

&header("Ticket History - Last $days Days - Duplicates and Suppressed Tickets Excluded"); 

&msg("Retrieving Data - Please wait ...");

#---- Connect to DB
&connectDB;

#---- Create report
&selectData;

close(LOG);
exit 0;
