create table dbamon.metrics_daily
  (
    dbamonmode       varchar(8)                not null,
    instance         varchar(80)               not null,
    system           varchar(80)               not null,
    dbms             varchar(16)               not null,
    category         varchar(64)               not null,
    parm             varchar(64)               not null,
    min              numeric(15,2)             not null,
    max              numeric(15,2)             not null,
    avg              numeric(15,2)             not null,
    sum              numeric(15,2)             not null,
    ts               datetime2(0)              not null, 
    zdate_char       varchar(19)               not null,
    zdate            datetime2(0)              default getdate() 
  );

create index metrics_daily_x1 on dbamon.metrics_daily (ts) ;
create index metrics_daily_x2 on dbamon.metrics_daily (instance,system) ;
create unique index metrics_daily_x3 on dbamon.metrics_daily (dbamonmode,instance,system,dbms,category,parm,ts) ;
